Package: spuRs
Type: Package
Title: Functions and Datasets for "Introduction to Scientific
        Programming and Simulation Using R"
Version: 2.0.3
Date: 2025-04-27
Authors@R: c(person(given = "Owen",
                      family = "Jones",
                      role = "aut"),
               person(given = "Robert",
                      family = "Maillardet",
                      role = "aut"),
               person(given = "Andrew",
                      family = "Robinson",
                      role = c("aut", "cre"),
                      email = "apro@unimelb.edu.au"),
               person(given = "Olga",
                      family = "Borovkova",
                      role = "aut"),
               person(given = "Steven",
                      family = "Carnie",
                      role = "aut"))
Maintainer: Andrew Robinson <apro@unimelb.edu.au>
Depends: R (>= 2.10), MASS, lattice
Description: Provides functions and datasets from Jones, O.D., R. Maillardet, and A.P. Robinson.  2014.  An Introduction to Scientific Programming and Simulation, Using R. 2nd Ed. Chapman And Hall/CRC.
License: GPL-3
LazyLoad: yes
NeedsCompilation: no
Packaged: 2025-04-27 12:35:12 UTC; apro
Author: Owen Jones [aut],
  Robert Maillardet [aut],
  Andrew Robinson [aut, cre],
  Olga Borovkova [aut],
  Steven Carnie [aut]
Repository: CRAN
Date/Publication: 2025-04-27 13:10:01 UTC
Built: R 4.6.0; ; 2026-04-25 22:33:22 UTC; unix

Package: spuRs
Type: Package
Title: Functions and Datasets for "Introduction to Scientific
        Programming and Simulation Using R"
Version: 2.0.3
Date: 2025-04-27
Authors@R: c(person(given = "Owen",
                      family = "Jones",
                      role = "aut"),
               person(given = "Robert",
                      family = "Maillardet",
                      role = "aut"),
               person(given = "Andrew",
                      family = "Robinson",
                      role = c("aut", "cre"),
                      email = "apro@unimelb.edu.au"),
               person(given = "Olga",
                      family = "Borovkova",
                      role = "aut"),
               person(given = "Steven",
                      family = "Carnie",
                      role = "aut"))
Maintainer: Andrew Robinson <apro@unimelb.edu.au>
Depends: R (>= 2.10), MASS, lattice
Description: Provides functions and datasets from Jones, O.D., R. Maillardet, and A.P. Robinson.  2014.  An Introduction to Scientific Programming and Simulation, Using R. 2nd Ed. Chapman And Hall/CRC.
License: GPL-3
LazyLoad: yes
NeedsCompilation: no
Packaged: 2025-04-27 12:35:12 UTC; apro
Author: Owen Jones [aut],
  Robert Maillardet [aut],
  Andrew Robinson [aut, cre],
  Olga Borovkova [aut],
  Steven Carnie [aut]
Repository: CRAN
Date/Publication: 2025-04-27 13:10:01 UTC
Built: R 4.6.0; ; 2026-04-27 03:51:39 UTC; unix

import(MASS)
import(lattice)

importFrom("graphics", "axis", "lines", "plot")
importFrom("stats", "rexp", "runif", "sd", "simulate", "weighted.mean")
importFrom("utils", "str")

S3method(mean, transectHolder)
S3method(print, transectHolder)


S3method(simulate, transectHolder)

S3method(mean, trapTransect)
S3method(print, trapTransect)

exportPattern("^[^\\.]")

# spurs



## Install

`pip install spurs`

`conda install spurs`

## How to use

Installation will create a command line script `spurs`:

```bash
spurs 20150608_20170808.int
```
By default, will output to file `20150608_20170808.unw` matching the name.

To increase the tolerance (from `pi/10` radians) for faster convergence, showing iteration stats:
```bash
spurs 20150608_20170808.int -o 20150608_20170808.unw --tol .5 --debug
```

See `spurs --help` for all options.

Note that for input interferograms which aren't complex, float32 binary format, `gdal` must be installed. E.g. for a VRT input:

```bash
spurs 20150608_20170808.vrt -o 20150608_20170808.unw
```



spurs is an open source implementation of [1]:

## References

1. Chartrand, Rick, Matthew T. Calef, and Michael S. Warren. "Exploiting Sparsity for Phase Unwrapping." IGARSS 2019-2019 IEEE International Geoscience and Remote Sensing Symposium. IEEE, 2019.

# program spuRs/resources/scripts/MCSimulation.r
# loadable spuRs function

# Discrete time Markov Chain Simulation
# This function simulates a discrete MC with transition matrix P,
# state space {0,1,..,n}, and initial state i for nsteps transitions

MCSimulation <- function(P, i, nsteps){
  n <- nrow(P) - 1
  statehist <- c(i, rep(0, nsteps))
  for (step in 2:(nsteps+1)){
    statehist[step] <- sample(0:n, 1, prob=P[1+statehist[step-1],])
  }
  return(statehist)
}

# program spuRs/resources/scripts/powers.r
# display powers 1 to n of x

# input
x <- 7
n <- 5

# display powers
cat("Powers of", x, "\n")
cat("exponent    result\n\n")

result <- 1
for (i in 1:n) {
  result <- result * x
  cat(format(i, width = 8),
      format(result, width = 10),
      "\n", sep = "")
}

# program spuRs/resources/scripts/CMCSimulation.r
# loadable spuRs function

# Continuous time Markov Chain Simulation
# This function simulates a continuous time MC with
# state space {0, 1, ..., n}, rate matrix Q, and initial state i
# over the period (0, Tend).  It returns the realisation
# cbind(statehist, timehist) where the vector statehist gives the 
# successive states of the jump process and the vector
# timehist the jump times.
# It also plots the realisation if plotflag is TRUE

CMCSimulation <- function(Q, i, Tend, plotflag = FALSE){
  n <- nrow(Q) - 1
  rates <- -diag(Q)
  P <- diag(1/rates) %*% Q + diag(1, n+1)
  currentstate <- i
  time <- 0
  statehist <- currentstate
  timehist <- time
  jump <- 1
  
  while (time < Tend){
  	time <- time + rexp(1, rates[currentstate+1])
  	timehist[jump+1] <- time
  	currentstate <- sample(0:n, 1, prob=P[currentstate+1,])
  	statehist[jump+1] <- currentstate
  	jump <- jump + 1
  }
  
  if (plotflag) {
    plot(timehist, statehist, type="s", xlab="Time", ylab="State", 
         ylim=c(0,n), xlim=c(0,Tend), yaxt="n")
    axis(2, at=0:n)
  }
  return(cbind(statehist, timehist)) 
}

# program: spuRs/resources/scripts/discrete_queue.r
# Discrete Queue Simulation

# inputs
lambda <- 1     # arrival rate
mu <- 1.1       # service rate
t.end <- 100    # duration of simulation
t.step <- 0.05  # time step
rand.seed <- 99 # seed for random number generator

# simulation
set.seed(rand.seed)
queue <- rep(0, t.end/t.step + 1)
for (i in 2:length(queue)) {
  if (runif(1) < lambda*t.step) { # arrival
    queue[i] <- queue[i-1] + 1
  } else if (runif(1) < mu*t.step) { # potential departure
    queue[i] <- max(0, queue[i-1] - 1)
  } else { # nothing happens
    queue[i] <- queue[i-1]
  }
}

# output
plot(seq(from=0, to=t.end, by=t.step), queue, type='l', 
    xlab='time', ylab='queue size')
title(paste('Queuing Simulation. Arrival rate:', lambda,
    'Service rate:', mu))

# program spuRs/resources/scripts/quad3.r

quad3 <- function(a0, a1, a2) {
  # find the zeros of a2*x^2 + a1*x + a0 = 0
  if (a2 == 0 && a1 == 0 && a0 == 0) {
    roots <- NA
  } else if (a2 == 0 && a1 == 0) {
    roots <- NULL
  } else if (a2 == 0) {
    roots <- -a0/a1
  } else {
    # calculate the discriminant
    discrim <- a1^2 - 4*a2*a0
    # calculate the roots depending on the value of the discriminant
    if (discrim > 0) {
        roots <- (-a1 + c(1,-1) * sqrt(a1^2 - 4*a2*a0))/(2*a2)
    } else if (discrim == 0) {
        roots <- -a1/(2*a2)
    } else {
        roots <- NULL
    }
  }
  return(roots)
}

# program spuRs/resources/scripts/life.r

neighbours <- function(A, i, j, n) {
    # A is an n*n 0-1 matrix
    # calculate number of neighbours of A[i,j]
    .
    .
    .
}

# grid size
n <- 50

# initialise lattice
A <- matrix(round(runif(n^2)), n, n)

finished <- FALSE
while (!finished) {
    # plot
    plot(c(1,n), c(1,n), type = "n", xlab = "", ylab = "")
    for (i in 1:n) {
        for (j in 1:n) {
            if (A[i,j] == 1) {
                points(i, j)
            }
        }
    }
    
    # update
    B <- A
    for (i in 1:n) {
        for (j in 1:n) {
            nbrs <- neighbours(A, i, j, n)
            if (A[i,j] == 1) {
                if ((nbrs == 2) | (nbrs == 3)) {
                    B[i,j] <- 1
                } else {
                    B[i,j] <- 0
                }
            } else {
                if (nbrs == 3) {
                    B[i,j] <- 1
                } else {
                    B[i,j] <- 0
                }
            }
        }
    }
    A <- B
    
    ## continue?
    #input <- readline("stop? ")
    #if (input == "y") finished <- TRUE
}

# program spuRs/resources/scripts/inventory_2stage_sim.r

rm(list=ls())
set.seed(1939)

add.event <- function(event.list, new.event) {
  # add new.event to event.list
  N <- length(event.list)
  if (N == 0) return(list(new.event))
  # find position n of new.event
  n <- 1
  while ((n <= N) && (new.event$time > event.list[[n]]$time)) {
    n <- n + 1
  }
  # insert new.event
  if (n == 1) {
    event.list <- c(list(new.event), event.list)
  } else if (n == N + 1) {
    event.list <- c(event.list, list(new.event))
  } else {
    event.list <- c(event.list[1:(n-1)], list(new.event), event.list[n:N])
  }
  return(event.list)
}

# inputs
# system parameters
D <- 1000
L1 <- 0.01
L2 <- 0.1
K1 <- 100
K2 <- 1000
p <- 10
h1 <- 500
h2 <- 10
s <- 200
# control parameters
q1 <- 30
r1 <- 15
q2 <- 10*q1
r2 <- 3*q1
b <- 0.005

# initialise system and event list
n <- 0  # number of events so far
t <- 0  # time
stock.store <- r1
stock.depot <- r2
costs <- 0
event.list <- list(list(type = "purchase", time = rexp(1, rate = D)))
event.list <- add.event(event.list, list(type = "new stock store", time = L1))
event.list <- add.event(event.list, list(type = "new stock depot", time = L2))
# simulation
while (t[n+1] < 1) {
  # get next event
  current.event <- event.list[[1]]
  event.list <- event.list[-1]
  n <- n + 1
  # update state and event list according to type of current event
  if (current.event$type == "purchase") {
    # update system state
    t[n+1] <- current.event$time
    costs[n+1] <- costs[n] + h1*stock.store[n]*(t[n+1] - t[n])
                           + h2*stock.depot[n]*(t[n+1] - t[n])
    if (stock.store[n] > 0) {
      stock.store[n+1] <- stock.store[n] - 1
    } else {
      costs[n+1] <- costs[n+1] + s
      stock.store[n+1] <- stock.store[n]
    }
    stock.depot[n+1] <- stock.depot[n]
    # generate next purchase
    new.event <- list(type = "purchase", time = t[n+1] + rexp(1, rate = D))
    event.list <- add.event(event.list, new.event)
    # check stock levels
    if (stock.store[n+1] == r1) {
      # order more stock for store
      if (stock.depot[n+1] >= q1) {
        new.event <- list(type = "new stock store", time = t[n+1] + L1)
        event.list <- add.event(event.list, new.event)
        costs[n+1] <- costs[n+1] + K1
        stock.depot[n+1] <- stock.depot[n+1] - q1
        # order more stock for depot
        if (stock.depot[n+1] == r2) {
          new.event <- list(type = "new stock depot", time = t[n+1] + L2)
          event.list <- add.event(event.list, new.event)
          costs[n+1] <- costs[n+1] + K2 + p*q2
        }
      # depot out of stock
      } else {
        new.event <- list(type = "backlogged order", time = t[n+1] + b)
        event.list <- add.event(event.list, new.event)
      }
    }
  } else if (current.event$type == "new stock store") {
    # update system state
    t[n+1] <- current.event$time
    costs[n+1] <- costs[n] + h1*stock.store[n]*(t[n+1] - t[n])
                           + h2*stock.depot[n]*(t[n+1] - t[n])
    stock.store[n+1] <- stock.store[n] + q1
    stock.depot[n+1] <- stock.depot[n]
  } else if (current.event$type == "new stock depot") {
    # update system state
    t[n+1] <- current.event$time
    costs[n+1] <- costs[n] + h1*stock.store[n]*(t[n+1] - t[n])
                           + h2*stock.depot[n]*(t[n+1] - t[n])
    stock.store[n+1] <- stock.store[n]
    stock.depot[n+1] <- stock.depot[n] + q2
  } else if (current.event$type == "backlogged order") {
    # update system state
    t[n+1] <- current.event$time
    costs[n+1] <- costs[n] + h1*stock.store[n]*(t[n+1] - t[n])
                           + h2*stock.depot[n]*(t[n+1] - t[n])
    stock.store[n+1] <- stock.store[n]
    stock.depot[n+1] <- stock.depot[n]
    # order more stock for store
    if (stock.depot[n+1] >= q1) {
      new.event <- list(type = "new stock store", time = t[n+1] + L1)
      event.list <- add.event(event.list, new.event)
      costs[n+1] <- costs[n+1] + K1
      stock.depot[n+1] <- stock.depot[n+1] - q1
      # order more stock for depot
      if (stock.depot[n+1] == r2) {
        new.event <- list(type = "new stock depot", time = t[n+1] + L2)
        event.list <- add.event(event.list, new.event)
        costs[n+1] <- costs[n+1] + K2 + p*q2
      }
    # depot out of stock
    } else {
      new.event <- list(type = "backlogged order", time = t[n+1] + b)
      event.list <- add.event(event.list, new.event)
    }
  }
}

opar <- par(mfrow = c(3, 1), mar=c(4, 4, 1, 4), oma=c(0,0,4,0))
plot(t, stock.store, type = "s", ylim = c(0, max(stock.store)), ylab="Stock (Store)")
plot(t, stock.depot, type = "s", ylim = c(0, max(stock.depot)), ylab="Stock (Depot)")
plot(t, costs, type = "l", ylab="Costs")
par <- opar

# program spuRs/resources/scripts/quad2.r
# find the zeros of a2*x^2 + a1*x + a0 = 0

# clear the workspace
rm(list=ls())

# input
a2 <- 1
a1 <- 4
a0 <- 5

# calculate the discriminant
discrim <- a1^2 - 4*a2*a0
# calculate the roots depending on the value of the discriminant
if (discrim > 0) {
    roots <- c( (-a1 + sqrt(a1^2 - 4*a2*a0))/(2*a2),
               (-a1 - sqrt(a1^2 - 4*a2*a0))/(2*a2) )
} else {
    if (discrim == 0) {
        roots <- -a1/(2*a2)
    } else {
        roots <- c()
    }
}

# output
show(roots)

# program spuRs/resources/scripts/n_choose_r.r

n_factorial <- function(n) {
    # Calculate n factorial
    n_fact <- prod(1:n)
    return(n_fact)
}

n_choose_r <- function(n, r) {
    # Calculate n choose r
    n_ch_r <- n_factorial(n)/n_factorial(r)/n_factorial(n-r)
    return(n_ch_r)
}

# program spuRs/resources/scripts/Phi.r
# estimate and plot the normal cdf Phi

rm(list = ls()) # clear the workspace
source("../scripts/simpson_n.r")
phi <- function(x) return(exp(-x^2/2)/sqrt(2*pi))
Phi <- function(z) {
  if (z < 0) {
    return(0.5 - simpson_n(phi, z, 0))
  } else {
    return(0.5 + simpson_n(phi, 0, z))
  }
}

z <- seq(-5, 5, by = 0.1)
phi.z <- sapply(z, phi)
Phi.z <- sapply(z, Phi)
plot(z, Phi.z, type = "l", ylab = "", main = "phi(z) and Phi(z)")
lines(z, phi.z)

# program: spuRs/resources/scripts/compound.r
# Duration of a loan under compound interest

# clear the workspace
rm(list=ls())

# Inputs
r <- 0.11             # Annual interest rate
period <- 1/12        # Time between repayments (in years)
debt_initial <- 1000  # Amount borrowed
repayments <- 12      # Amount repaid each period

# Calculations
time <- 0
debt <- debt_initial
while (debt > 0) {
    time <- time + period
    debt <- debt*(1 + r*period) - repayments
}

# Output
cat('Loan will be repaid in', time, 'years\n')

# Code spuRs/resources/scripts/euler.r

euler <- function(dydt, t0, y0, h, n, ...) {
  # Euler's method applied to the system of ODEs with grad ftn dydt
  # and initial condition y0 at time t0
  # simulates n steps of size h, returned in a matrix with n + 1 rows 
  # and cols corresponding to the elements of y
  # additional arguments are passed to dydt
  y <- matrix(0, nrow = n + 1, ncol = length(y0))
  y[1,] <- y0
  t <- t0
  for (i in 1:n) {
    y[i+1,] <- y[i,] + h*dydt(t, y[i,], ...)
    t <- t + h
  }
  return(y)
}

# program: spuRs/resources/scripts/ppoint.r

phi <- function(x) return(exp(-x^2/2)/sqrt(2*pi))

ppoint <- function(p, pdf = phi, z.min = -10, tol = 1e-9) {
  # calculate a percentage point
  #
  # p is assumed to be between 0 and 1
  # pdf is assumed to be a probability density function
  #
  # let F(x) be the integral of pdf from -infinity to x
  # we apply the Newton-Raphson algorithm to find z_p such that
  # F(z_p) = p, that is, to find z_p such that F(z_p) - p = 0
  # note that the derivative of F(z) - p is just pdf(z)
  #
  # we approximate -infinity by z.min (that is, we assume that 
  # the integral of pdf from -infinity to z.min is negligible)

  # do first iteration
  x <- 0
  f.x <- simpson_n(pdf, z.min, x) - p
  # continue iterating until stopping conditions are met
  while (abs(f.x) > tol) {
    x <- x - f.x/pdf(x)
    f.x <- simpson_n(pdf, z.min, x) - p
  }
  return(x)
}

# program: spuRs/resources/scripts/search.r
# Search for a string in a file.

# Clear the work space
rm(list=ls())

# Input
# Assume that the file file_name consists of character strings
# separated by newlines. target is the string to search for
file_name = "../data/cars.txt"
target = "Triumph"

# Open connection
input_file = file(file_name, open = "r")

# Scan until target found or we've reached the end of the file
found = FALSE  # has the target been found yet
eof = FALSE    # are we at the end of the file
n = 0          # number of lines read
while (!found && !eof) {
    str <- scan(input_file, what="a", n=1, sep="\n", quiet=TRUE)
    n = n + 1
    if (length(str) == 0) {
        eof <- TRUE
    } else if (str == target) {
        found <- TRUE
    }
}
close(input_file)

# Output
if (eof) {
    cat("End of file reached without finding target\n")
} else {
    cat("Target found at line", n, "\n")
}

# Program spuRs/resources/scripts/bp.r
# branching process simulation

bp <- function(gen, rv.sim, ...) {
  # population of a branching process from generation 0 to gen
  # rv.sim(n, ...) simulates n rv's from the offspring distribution
  # Z[i] is population at generation i-1; Z[1] = 1
  Z <- rep(0, gen+1)
  Z[1] <- 1
  for (i in 1:gen) {
    if (Z[i] > 0) {
      Z[i+1] <- sum(rv.sim(Z[i], ...))
    }
  }
  return(Z)
}

bp.plot <- function(gen, rv.sim, ..., reps = 1, logplot = TRUE) {
  # simulates and plots the population of a branching process
  # from generation 0 to gen; rv.sim(n, ...) simulates n rv's
  # from the offspring distribution
  # the plot is repeated reps times
  # if logplot = TRUE then the population is plotted on a log scale
  # Z[i,j] is population at generation j-1 in the i-th repeat
  Z <- matrix(0, nrow = reps, ncol = gen+1)
  for (i in 1:reps) {
    Z[i,] <- bp(gen, rv.sim, ...)
  }
  if (logplot) {
    Z <- log(Z)
  }
  plot(c(0, gen), c(0, max(Z)), type = "n", xlab = "generation",
    ylab = if (logplot) "log population" else "population")
  for (i in 1:reps) {
    lines(0:gen, Z[i,])
  }
  return(invisible(Z))
}

Ti_lander <- function(a) {
  # Given thrust a, find the optimal time Ti to fire the rocket
  # We assume the optimal time is less than Tmax
  Tmax <- 100
  g <- function(Ti) {
    l.out <- lander(Ti, a)
    return(100*min(l.out[1], 0) - max(l.out[2], 0))
  }
  Ti <- optimize(g, c(0, Tmax), maximum=T)$maximum
  return(Ti)
}

kew <- read.table("../data/kew.txt", col.names=c("year", "jan", "feb",
    "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec"))
kew[,2:13] <- kew[,2:13]/10
kew.mean <- apply(kew[-1], 2, mean)
kew.var <- apply(kew[-1], 2, var)
lambda.mm <- kew.mean/kew.var
m.mm <- kew.mean^2/kew.var
hist(kew$jul, breaks=20, freq=FALSE, xlab="rainfall (mm)",
    ylab="density", main="July rainfall at Kew, 1697 to 1999")
t <- seq(0, 200, 0.5)
lines(t, dgamma(t, m.mm[7], lambda.mm[7]), lty=2)
x <- kew$jul
x[x == 0] <- 0.1
newtonraphson <- function(ftn, x0, tol = 1e-9, max.iter = 100, ...) {
  # find a root of ftn(x, ...) near x0 using Newton-Raphson
  # initialise
  x <- x0
  fx <- ftn(x, ...)
  iter <-  0
  # continue iterating until stopping conditions are met
  while ((abs(fx[1]) > tol) & (iter < max.iter)) {
    x <- x - fx[1]/fx[2]
    fx <- ftn(x, ...)
    iter <-  iter + 1
  }
  # output depends on success of algorithm
  if (abs(fx[1]) > tol) {
    stop("Algorithm failed to converge\n")
  } else {
    return(x)
  }
}
dl <- function(m, a) {
  return(c(log(m) - digamma(m) - a, 1/m - trigamma(m)))
}
m.ml <- newtonraphson(dl, m.mm[7], a = log(mean(x)) - mean(log(x)))
lambda.ml <- m.ml/mean(x)
lines(t, dgamma(t, m.ml, lambda.ml))

# program spuRs/resources/scripts/SIRsim.r

SIRsim <- function(a, b, N, T) {
  # Simulate an SIR epidemic
  # a is infection rate, b is removal rate
  # N initial susceptibles, 1 initial infected, simulation length T
  # returns a matrix size (T+1)*3 with columns S, I, R respectively
  S <- rep(0, T+1)
  I <- rep(0, T+1)
  R <- rep(0, T+1)
  S[1] <- N
  I[1] <- 1
  R[1] <- 0
  for (i in 1:T) {
    S[i+1] <- rbinom(1, S[i], (1 - a)^I[i])
    R[i+1] <- R[i] + rbinom(1, I[i], b)
    I[i+1] <- N + 1 - R[i+1] - S[i+1]
  }
  return(matrix(c(S, I, R), ncol = 3))
}

a_lander <- function(amax) {
  # Find that thrust a and firing time Ti which land the rocket using
  # the least fuel. amax is the maximum thrust possible
  g <- function(a) {
    Ti <- Ti_lander(a)
    return(lander(Ti, a)[3])
  }
  opt <- optimize(g, c(0, amax), maximum=T)
  a <- opt$maximum     # optimal thrust
  mf <- opt$objective  # final mass
  return(c(Ti_lander(a), a, mf))
}

# Program spuRs/resources/scripts/play_game.r

play_game <- function(a, b) {
    state <- c(0, 0, 1)
    while (status(state[1], state[2]) == "unfinished") {
        # show(state)
        state <- play_point(state, a, b)
    }
    if (status(state[1], state[2]) == "player 1 win") {
        return(TRUE)
    } else {
        return(FALSE)
    }
}

# Program spuRs/resources/scripts/change.r

change <- function(x, y.vec = c()) {
  # finds possible ways of making up amount x using Australian coins
  # x is given in cents and we assume it is divisible by 5
  # y.vec are coins already used (so total amount is x + sum(y.vec))
  if (x == 0) {
    cat(y.vec, "\n")
  } else {
    coins <- c(200, 100, 50, 20, 10, 5)
    new.x <- x - coins
    new.x <- new.x[new.x >= 0]
    for (z in new.x) {
      y.tmp <- c(y.vec, x - z)
      if (identical(y.tmp, sort(y.tmp))) {
        change(z, y.tmp)
      }
    }
  }
  return(invisible(NULL))
}

# Program spuRs/resources/scripts/gsection.r

gsection <- function(ftn, x.l, x.r, x.m, tol = 1e-9) {
  # applies the golden-section algorithm to maximise ftn
  # we assume that ftn is a function of a single variable
  # and that x.l < x.m < x.r and ftn(x.l), ftn(x.r) <= ftn(x.m)
  #
  # the algorithm iteratively refines x.l, x.r, and x.m and terminates
  # when x.r - x.l <= tol, then returns x.m

  # golden ratio plus one
  gr1 <- 1 + (1 + sqrt(5))/2

  # successively refine x.l, x.r, and x.m
  f.l <- ftn(x.l)
  f.r <- ftn(x.r)
  f.m <- ftn(x.m)
  while ((x.r - x.l) > tol) {
    if ((x.r - x.m) > (x.m - x.l)) {
      y <- x.m + (x.r - x.m)/gr1
      f.y <- ftn(y)
      if (f.y >= f.m) {
        x.l <- x.m
        f.l <- f.m
        x.m <- y
        f.m <- f.y
      } else {
        x.r <- y
        f.r <- f.y
      }
    } else {
      y <- x.m - (x.m - x.l)/gr1
      f.y <- ftn(y)
      if (f.y >= f.m) {
        x.r <- x.m
        f.r <- f.m
        x.m <- y
        f.m <- f.y
      } else {
        x.l <- y
        f.l <- f.y
      }
    }
  }
  return(x.m)
}

# program spuRs/resources/scripts/ev_web.r

popsize <- 16 # size of population, must be even
r_mutate <- 0.25 # proportion of each generation mutated
# set up plotting
opar <- par(mfrow=c(4,4), mar=c(0,0,0,0), oma=c(0,0,0,0))
# set up initial population of webs, each consisting of a
# single strand
population <- list()
for (i in 1:popsize) {
  population <- c(population, list(runif(2, 0, 2*pi)))
}
# main loop
continue <- TRUE # flag to continue searching
n_gen <- 1 # num of generations in next batch
total_gen <- 0 # total generations so far
while (continue) {
  for (gen in 1:n_gen) {
    # mutate
    for (i in 1:popsize) {
      if (runif(1) < r_mutate) {
        population[[i]] <- mutate(population[[i]])
      }
    }
    # recombine
    x <- sample(1:popsize, popsize/2)
    y <- (1:popsize)[-x]
    for (i in 1:(popsize/2)) {
      population <- c(population, recombine(population[[x[i]]],
                                            population[[y[i]]]))
    }
    # select
    fitness <- rep(0, 2*popsize)
    for (i in 1:(2*popsize)) {
      fitness[i] <- efficiency(population[[i]])
    }
    fittest <- order(fitness, decreasing=TRUE)
    population <- population[fittest[1:popsize]]
    cat(".") # so we know something is happening
  }
  # report
  total_gen <- total_gen + n_gen
  cat("\nbest efficiency after", total_gen,
      "generations is", fitness[fittest[1]], "\n")
  for (i in 1:popsize) webdraw(population[[i]])
  # get num of generations in next batch, zero to stop
  n_gen <- as.numeric(readline("number of extra generations: "))
  continue <- n_gen > 0
}
par <- opar

# program spuRs/resources/scripts/newtonraphson.r
# loadable spuRs function

newtonraphson <- function(ftn, x0, tol = 1e-9, max.iter = 100) {
  # Newton_Raphson algorithm for solving ftn(x)[1] == 0
  # we assume that ftn is a function of a single variable that returns
  # the function value and the first derivative as a vector of length 2
  #
  # x0 is the initial guess at the root
  # the algorithm terminates when the function value is within distance
  # tol of 0, or the number of iterations exceeds max.iter

  # initialise
  x <- x0
  fx <- ftn(x)
  iter <-  0

  # continue iterating until stopping conditions are met
  while ((abs(fx[1]) > tol) && (iter < max.iter)) {
    x <- x - fx[1]/fx[2]
    fx <- ftn(x)
    iter <- iter + 1
    cat("At iteration", iter, "value of x is:", x, "\n")
  }

  # output depends on success of algorithm
  if (abs(fx[1]) > tol) {
    cat("Algorithm failed to converge\n")
    return(NULL)
  } else {
    cat("Algorithm converged\n")
    return(x)
  }
}

# program spuRs/resources/scripts/bp_grid.r

bp.sim <- function(gen, rv.sim, ...) {
  # population of a branching process at generation gen
  # rv.sim(n, ...) simulates n rv's from the offspring distribution
  Z <- 1
  for (i in 1:gen) {
    if (Z > 0) {
      Z <- sum(rv.sim(Z, ...))
    }
  }
  return(Z)
}


# set parameter values
gen <- 50
size <- 2
prob <- seq(0.3, 0.6, by = 0.01)
n.reps <- 100 # sample size for estimating E Z

# estimate E Z for each value of prob
mu <- rep(0, length(prob))
Z.mean <- rep(0, length(prob))
for (i in 1:length(prob)) {
  Z.sum <- 0
  for (k in 1:n.reps) {
    Z.sum <- Z.sum + bp.sim(gen, rbinom, size, prob[i])
  }
  mu[i] <- size*prob[i]
  Z.mean[i] <- Z.sum/n.reps
}

# plot estimates
# note that values of log(0) (= -infinity) are not plotted
plot(mu, log(Z.mean), type = "o",
     xlab = "E family size", ylab = paste("log pop at gen", gen))

chute <- function(Ti, h = 0.1, tol = 1e-4, plot.traj = F) {
  # Missing code is denoted ??
  #
  # Trajectory of a skydiver
  # Ti is time to open parachute
  # state y = (velocity, height)

  g <- 9.81   # acceleration due to gravity m/s^2
  m <- 100    # mass of skydiver kg
  d1 <- 0.31  # drag without chute kg/m
  d2 <- 56    # drag with chute kg/m
  ht0 <- 2000 # jump height m
  # d1 is obtained from terminal velocity for a 100kg person of 200 km/h
  # d2 is obtained from terminal velocity for a 100kg parachute of 15 km/h
  
  # derivatives of y at time x
  dydx <- function(x, y) {
    ??
  }
  
  # 4-th order Runge-Kutta with adaptive step size
  x <- 0
  y <- ??  # initial conditions
  if (plot.traj) y.trace <- c(x, y)
  while (??) {  # stopping criteria
    # readline(paste(x, y[1], y[2]))  # for diagnostics
    # RK4 using step size h
    k1 <- h*dydx(x, y)
    k2 <- h*dydx(x + h/2, y + k1/2)
    k3 <- h*dydx(x + h/2, y + k2/2)
    k4 <- h*dydx(x + h, y + k3)
    y1 <- y + k1/6 + k2/3 + k3/3 + k4/6
    # RK4 using two steps size h/2
    k1a <- k1/2
    k2a <- h/2*dydx(x + h/4, y + k1a/2)
    k3a <- h/2*dydx(x + h/4, y + k2a/2)
    k4a <- h/2*dydx(x + h/2, y + k3a)
    y2 <- y + k1a/6 + k2a/3 + k3a/3 + k4a/6
    k1b <- h/2*dydx(x + h/2, y2)
    k2b <- h/2*dydx(x + 3*h/4, y2 + k1b/2)
    k3b <- h/2*dydx(x + 3*h/4, y2 + k2b/2)
    k4b <- h/2*dydx(x + h, y2 + k3b)
    y3 <- y2 + k1b/6 + k2b/3 + k3b/3 + k4b/6
    y.new <- y3 + (y3 - y1)/15
    # update h
    if (max(abs(y3 - y1)) > tol || y.new[2] < -tol) {
      h <- h/2
    } else {
      # update x and y
      x <- x + h
      y <- y.new
      # update h
      if (max(abs(y3 - y1)) < tol/2) h <- 3*h/2
      # record keeping
      if (plot.traj) y.trace <- rbind(y.trace, c(x, y))
    }
  }  
  
  # output
  if (plot.traj) {
    opar <- par(mfrow=c(2,1), mar=c(4,4,1,1))
    plot(y.trace[,1], y.trace[,2], type='o', xlab='t', ylab='velocity')
    plot(y.trace[,1], y.trace[,3], type='o', xlab='t', ylab='height')
    par <- opar
  }
  return(c(x, y))
}

# safe landing speed is 20 km/h = 5.6 m/s

# program spuRs/resources/scripts/predprey.r
# Lotka-Volterra predator-prey equations
br <- 0.04   # growth rate of rabbits
dr <- 0.0005 # death rate of rabbits due to predation
df <- 0.2    # death rate of foxes
bf <- 0.1    # efficiency of turning predated rabbits into foxes
x <- 4000
y <- 100
while (x > 3900) {
  # cat("x =", x, " y =", y, "\n")
  x.new <- (1+br)*x - dr*x*y
  y.new <- (1-df)*y + bf*dr*x*y
  x <- x.new
  y <- y.new
}

# Program spuRs/resources/scripts/ascent.r

source("../scripts/linesearch.r")

ascent <- function(f, grad.f, x0, tol = 1e-9, n.max = 100) {
    # steepest ascent algorithm
    # find a local max of f starting at x0
    # function grad.f is the gradient of f
    
    x.old <- x0
    x <- line.search(f, x0, grad.f(x0))
    n <- 1
    while ((f(x) - f(x.old) > tol) & (n < n.max)) {
        x.old <- x
        x <- line.search(f, x, grad.f(x))
        n <- n + 1
    }
    return(x)
}

booking_clerkMC <- function(personArrRate,
                            callArrRate,
                            personServRate,
                            callServRate,
                            t.end) {
  
# simulate the harassed booking clerk using a Markov chain
# state is a vector length 3
# first element is clerk state 0/1/2 for idle/serve person/serve call
# second element is number of people waiting
# third element is number of calls waiting

t <- 0 # start time
state <- c(0,0,0) # start state
t.hist <- t
state.hist <- state
while (t < t.end) {
  if (state[1] == 0) { #clerk idle
    rate.out <- personArrRate + callArrRate
    u <- runif(1)
    if (u < personArrRate/rate.out) { # person arrives
      state <- c(1,0,0)
    } else { # call arrives
      state <- c(2,0,0)
    }
  } else if (state[1] == 1) { # clerk serving a person
    rate.out <- personArrRate + callArrRate + personServRate
    u <- runif(1)
    if (u < personArrRate/rate.out) { # person arrives
      state[2] <- state[2] + 1
    } else if (u < (personArrRate + callArrRate)/rate.out) { 
      # call arrives
      state[3] <- state[3] + 1
    } else { # finished serving
      if (state[2] > 0) { # still people
        state[2] <- state[2] - 1
      } else if (state[3] > 0) { # no people but calls
        state[1] <- 2
        state[3] <- state[3] - 1
      } else { # no people or calls
        state <- c(0,0,0)
      }
    }
  } else { # clerk serving a call
    rate.out <- personArrRate + callArrRate + callServRate
    u <- runif(1)
    if (u < personArrRate/rate.out) { # person arrives
      state[2] <- state[2] + 1
    } else if (u < (personArrRate + callArrRate)/rate.out) { 
      # call arrives
      state[3] <- state[3] + 1
    } else { # finished serving
      if (state[2] > 0) { # still people
        state[1] <- 1
        state[2] <- state[2] - 1
      } else if (state[3] > 0) { # no people but calls
        state[3] <- state[3] - 1
      } else { # no people or calls
        state <- c(0,0,0)
      }
    }
  }
  t <- t + rexp(1, rate.out)
  # data recording  
  t.hist <- c(t.hist, t)
  state.hist <- rbind(state.hist, state)
}   
out <- cbind(t.hist, state.hist)
colnames(out) <- c("time", "clerk", "people", "calls")
rownames(out) <- 1:dim(out)[1]
return(out)
}

# program spuRs/resources/scripts/seed-test.r

# set up two plots side-by-side
par(las = 1, mfrow = c(1,2), mar = c(4,5,0,2))

# graph f_R and f_T on the LHS plot
curve(dgamma(x, shape = 2, rate = 1/2), from = 0, to = 20,
      ylim = c(0, dexp(0, rate=1/2)), lty = 2,
      xlab = "r", ylab = expression(paste(f[T](r), " and ", f[R](r))))
curve(dexp(x, rate = 1/2), add = TRUE)
abline(h = 0, col = "grey")

# generate T, U, and S samples for case 1
T <- rexp(1000000, rate = 1/2)
U <- runif(1000000, min = 0, max = 20)
S <- T[T > U]

# graph estimate of f_S and f_R on the RHS plot
hist(S, breaks = seq(0, max(S)+0.5, 0.5), freq = FALSE,
     xlim = c(0,20), ylim = c(0, dexp(0, rate = 1/2)),
     main = "", xlab = "r",
     ylab = expression(paste(f[R](r), " and ", hat(f)[S](r))),
     col = "lightgrey", border = "darkgrey")
curve(dgamma(x, shape = 2, rate = 1/2), add = TRUE)

# program spuRs/resources/scripts/quadrature.r
# numerical integration using adaptive quadrature

quadrature <- function(ftn, a, b, tol = 1e-8, trace = FALSE) {
  # numerical integral of ftn from a to b
  # ftn is a function of one variable
  # the partition used is recursively refined until the
  # estimate on successive partitions differs by at most tol
  # if trace is TRUE then intermediate results are printed
  #
  # the main purpose of this function is to call function q.recursion
  #
  # the function returns a vector of length 2 whose first element
  # is the integral and whose second element is the number of
  # function evaluations required

  c = (a + b)/2
  fa <- ftn(a)
  fb <- ftn(b)
  fc <- ftn(c)
  h <- (b - a)/2
  I.start <- h*(fa + 4*fc + fb)/3 # Simpson's rule
  q.out <- q.recursion(ftn,a,b,c,fa,fb,fc,I.start,tol,1,trace)
  q.out[2] <- q.out[2] + 3
  if (trace) {
    cat("final value is", q.out[1], "in",
        q.out[2], "function evaluations\n")
  }
  return(q.out)
}

q.recursion <- function(ftn,a,b,c,fa,fb,fc,I.old,tol,level,trace) {
  # refinement of the numerical integral of ftn from a to b
  # ftn is a function of one variable
  # the current partition is [a, c, b]
  # fi == ftn(i)
  # I.old is the value of the integral I using the current partition
  # if trace is TRUE then intermediate results are printed
  # level is the current level of refinement/nesting
  #
  # the function returns a vector of length 2 whose first element
  # is the integral and whose second element is the number of
  # function evaluations required
  #
  # I.left and I.right are estimates of I over [a, c] and [c, b]
  # if |I.old - I.left - I.right| <= tol then we are done, otherwise 
  # I.left and I.right are recursively refined

  level.max <- 64
  if (level > level.max) {
    cat("recursion limit reached: singularity likely\n")
    return(NULL)
  } else {
    h <- (b - a)/4
    f1 <- ftn(a + h)
    f2 <- ftn(b - h)
    I.left <- h*(fa + 4*f1 + fc)/3  # Simpson's rule for left half
    I.right <- h*(fc + 4*f2 + fb)/3 # Simpson's rule for right half
    I.new <- I.left + I.right       # new estimate for the integral
    f.count <- 2

    if (abs(I.new - I.old) > tol) { # I.new not accurate enough
      q.left <- q.recursion(ftn, a, c, a + h, fa, fc, f1, I.left,
                            tol/2, level + 1, trace)
      q.right <- q.recursion(ftn, c, b, b - h, fc, fb, f2, I.right,
                             tol/2, level + 1, trace)
      I.new <- q.left[1] + q.right[1]
      f.count <-  f.count + q.left[2] + q.right[2];
    } else { # we have achieved the desired tolerance
      if (trace) {
        cat("integral over [", a, ", ", b, "] is ", I.new,
            " (at level ", level, ")\n", sep = "")
      }
    }

    return(c(I.new, f.count))
  }
}

# program spuRs/resources/scripts/newtonraphson_show.r
# loadable spuRs function

newtonraphson_show <- function(ftn, x0, xmin = x0-1, xmax = x0+1) {
  # applies Newton-Raphson to find x such that ftn(x)[1] == 0
  # x0 is the starting point
  # subsequent iterations are plotted in the range [xmin, xmax]

  # plot the function
  x <- seq(xmin, xmax, (xmax - xmin)/200)
  fx <- c()
  for (i in 1:length(x)) {
    fx[i] <- ftn(x[i])[1]
  }
  plot(x, fx, type = "l", xlab = "x", ylab = "f(x)",
    main = "zero f(x) = 0", col = "blue", lwd = 2)
  lines(c(xmin, xmax), c(0, 0), col = "blue")

  # do first iteration
  xold <- x0
  f.xold <- ftn(xold)
  xnew <- xold - f.xold[1]/f.xold[2]
  lines(c(xold, xold, xnew), c(0, f.xold[1], 0), col = "red")

  # continue iterating while user types "y"
  cat("last x value", xnew, " ")
  continue <- readline("continue (y or n)? ") == "y"
  while (continue) {
    xold <- xnew;
    f.xold <- ftn(xold)
    xnew <- xold - f.xold[1]/f.xold[2]
    lines(c(xold, xold, xnew), c(0, f.xold[1], 0), col = "red")
    cat("last x value", xnew, " ")
    continue <- readline("continue (y or n)? ") == "y"
  }

  return(xnew)
}

maxheads <- function(n.toss) {
  # returns the length of the longest sequence of heads
  # in a sequence of n.toss coin tosses
  n_heads = 0   # length of current head sequence
  max_heads = 0 # length of longest head sequence so far
  for (i in 1:n.toss) {
    # toss a coin and work out length of current head sequence
    if (runif(1) < 0.5) { # a head, sequence of heads increases by 1
      n_heads <- n_heads + 1
    } else { # a tail, sequence of heads goes back to 0
      n_heads <- 0
    };
    # see if current sequence of heads is the longest
    if (n_heads > max_heads) {
      max_heads <- n_heads
    }
  }
  return(max_heads)
}

#program spuRs/resources/scripts/simpson_n.r

simpson_n <- function(ftn, a, b, n = 100) {
  # numerical integral of ftn from a to b
  # using Simpson's rule with n subdivisions
  #
  # ftn is a function of a single variable
  # we assume a < b and n is a positive even integer

  n <- max(c(2*(n %/% 2), 4))
  h <- (b-a)/n
  x.vec1 <- seq(a+h, b-h, by = 2*h)
  x.vec2 <- seq(a+2*h, b-2*h, by = 2*h)
  f.vec1 <- sapply(x.vec1, ftn)
  f.vec2 <- sapply(x.vec2, ftn)
  S <- h/3*(ftn(a) + ftn(b) + 4*sum(f.vec1) + 2*sum(f.vec2))
  return(S)
}

# Code spuRs/resources/scripts/newton_gamma.r

newton <- function(f3, x0, tol = 1e-9, n.max = 100) {
    # Newton's method for optimisation, starting at x0
    # f3 is a function that given x returns the vector
    # (f(x), f'(x), f''(x)), for some f

    x <- x0
    f3.x <- f3(x)
    n <- 0
    while ((abs(f3.x[2]) > tol) & (n < n.max)) {
        x <- x - f3.x[2]/f3.x[3]
        f3.x <- f3(x)
        n <- n + 1
    }
    if (n == n.max) {
        cat('newton failed to converge\n')
    } else {
        return(x)
    }
}

gamma.2.3 <- function(x) {
    # gamma(2,3) density
    if (x < 0) return(c(0, 0, 0))
    if (x == 0) return(c(0, 0, NaN))
    y <- exp(-2*x)
    return(c(4*x^2*y, 8*x*(1-x)*y, 8*(2*x^2-4*x+1)*y))
}

test4 <- function(x, ...) {
  return(sd(x, ...))
}

test4(1:3)

test4(c(1,NA,3))

test4(c(1,NA,3), na.rm = TRUE)

test5 <- function(x, na.rm = FALSE, ...) {
  return(sd(x, ...))
}

test5(c(1,NA,3))

test5(c(1,NA,3), na.rm = TRUE)

test6 <- function(x, na.rm = FALSE, ...) {
  return(sd(x, na.rm = na.rm, ...))
}

test6(c(1,NA,3))

test6(c(1,NA,3), na.rm = TRUE)

# program spuRs/resources/scripts/simpson.r

simpson <- function(ftn, a, b, tol = 1e-8, verbose = FALSE) {
  # numerical integral of ftn from a to b
  # using Simpson's rule with tolerance tol
  #
  # ftn is a function of a single variable and a < b
  # if verbose is TRUE then n is printed to the screen

  # initialise
  n <- 4
  h <- (b - a)/4
  fx <- sapply(seq(a, b, by = h), ftn)
  S <- sum(fx*c(1, 4, 2, 4, 1))*h/3
  S.diff <- tol + 1  # ensures we loop at least once
  
  # increase n until S changes by less than tol
  while (S.diff > tol) {
    # cat('n =', n, 'S =', S, '\n')  # diagnostic
    S.old <- S
    n <- 2*n
    h <- h/2
    fx[seq(1, n+1, by = 2)] <- fx  # reuse old ftn values
    fx[seq(2, n, by = 2)] <- sapply(seq(a+h, b-h, by = 2*h), ftn)
    S <- h/3*(fx[1] + fx[n+1] + 4*sum(fx[seq(2, n, by = 2)]) +
         2*sum(fx[seq(3, n-1, by = 2)]))
    S.diff <- abs(S - S.old)
  }
  if (verbose) cat('partition size', n, '\n')
  return(S)
}

# spuRs/resources/scripts/primedensity.r
# estimate the density of primes (using a very inefficient algorithm)

# clear the workspace
rm(list=ls())

prime <- function(n) {
    # returns TRUE if n is prime
    # assumes n is a positive integer
    if (n == 1) {
        is.prime <- FALSE
    } else if (n == 2) {
        is.prime <- TRUE
    } else {
        is.prime <- TRUE
        for (m in 2:(n/2)) {
            if (n %% m == 0) is.prime <- FALSE
        }
    }
    return(is.prime)
}

# input
# we consider primes <= n
n <- 1000

# calculate the number of primes <= m for m in 2:n
# num.primes[i] == number of primes <= i+1
m.vec <- 2:n
primes <- sapply(m.vec, prime)
num.primes <- cumsum(primes)

# output
# plot the actual prime density against the theoretical limit
par(mfrow = c(1, 2), las = 1)
plot(m.vec, num.primes/m.vec, type = "l",
    main = "prime density", xlab = "n", ylab = "")
lines(m.vec, 1/log(m.vec), col = "red")

plot(m.vec, num.primes/m.vec*log(m.vec), type = "l",
    main = "prime density * log(n)", xlab = "n", ylab = "")

# Program spuRs/resources/scripts/linesearch.r

source("../scripts/gsection.r")

line.search <- function(f, x, y, tol = 1e-9, a.max = 2^5) {
    # f is a real function that takes a vector of length d
    # x and y are vectors of length d
    # line.search uses gsection to find a >= 0 such that
    #   g(a) = f(x + a*y) has a local maximum at a,
    #   within a tolerance of tol
    # if no local max is found then we use 0 or a.max for a
    # the value returned is x + a*y

    if (sum(abs(y)) == 0) return(x) # g(a) constant

    g <- function(a) return(f(x + a*y))

    # find a triple a.l < a.m < a.r such that
    # g(a.l) <= g(a.m) and g(a.m) >= g(a.r)
    # a.l
    a.l <- 0
    g.l <- g(a.l)
    # a.m
    a.m <- 1
    g.m <- g(a.m)
    while ((g.m < g.l) & (a.m > tol)) {
        a.m <- a.m/2
        g.m <- g(a.m)
    }
    # if a suitable a.m was not found then use 0 for a
    if ((a.m <= tol) & (g.m < g.l)) return(x)
    # a.r
    a.r <- 2*a.m
    g.r <- g(a.r)
    while ((g.m < g.r) & (a.r < a.max)) {
        a.m <- a.r
        g.m <- g.r
        a.r <- 2*a.m
        g.r <- g(a.r)
    }
    # if a suitable a.r was not found then use a.max for a
    if ((a.r >= a.max) & (g.m < g.r)) return(x + a.max*y)

    # apply golden-section algorithm to g to find a
    a <- gsection(g, a.l, a.r, a.m)
    return(x + a*y)
}

# program spuRs/resources/scripts/primesieve.r
# loadable spuRs function

primesieve <- function(sieved, unsieved) {
  # finds primes using the Sieve of Eratosthenes
  # sieved: sorted vector of sieved numbers
  # unsieved: sorted vector of unsieved numbers

  # cat("sieved", sieved, "\n")
  # cat("unsieved", unsieved, "\n")
  p <- unsieved[1]
  n <- unsieved[length(unsieved)]
  if (p^2 > n) {
      return(c(sieved, unsieved))
  } else {
      unsieved <- unsieved[unsieved %% p != 0]
      sieved <- c(sieved, p)
      return(primesieve(sieved, unsieved))
  }
}

# program spuRs/resources/scripts/swap.r

swap <- function(x) {
  # swap values of x[1] and x[2]
  y <- x[2]
  x[2] <- x[1]
  x[1] <- y
  return(x)
}

x <- c(7, 8, 9)
x[1:2] <- swap(x[1:2])
x[2:3] <- swap(x[2:3])

# programme: spuRs/resources/scripts/predprey2.r

T <- 500
a <- 0.04 # natural growth rate of rabbits in the absence of predation,
c <- 0.2 # natural death rate of foxes in the absence of food (rabbits),
b <- 0.0005 # death rate per encounter of rabbits due to predation,
e <- 0.1 # efficiency of turning predated rabbits into foxes.
x <- 4000
y <- 100
for (i in 1:T) {
  # cat("x =", x[i], " y =", y[i], "\n")
  x.new <- (1+a)*x[i] - b*x[i]*y[i]
  y.new <- (1-c)*y[i] + e*b*x[i]*y[i]
  x[i+1] <- x.new
  y[i+1] <- y.new
}
plot(x, y, type="l")
# text(x, y, 1:T)

# program spuRs/resources/scripts/newton.r

newton <- function(f3, x0, tol = 1e-9, n.max = 100) {
    # Newton's method for optimisation, starting at x0
    # f3 is a function that given x returns the list
    # {f(x), grad f(x), Hessian f(x)}, for some f

    x <- x0
    f3.x <- f3(x)
    n <- 0
    while ((max(abs(f3.x[[2]])) > tol) & (n < n.max)) {
        x <- x - solve(f3.x[[3]], f3.x[[2]])
        f3.x <- f3(x)
        n <- n + 1
    }
    if (n == n.max) {
        cat('newton failed to converge\n')
    } else {
        return(x)
    }
}

# program: spuRs/resources/scripts/quartiles1.r
# Calculate median and quartiles.

# Clear the workspace
rm(list=ls())

# Input
# We assume that the file file_name consists of numeric values
# separated by spaces and/or newlines
file_name = "../data/data1.txt"

# Read from file
data <- scan(file = file_name)

# Calculations
n <- length(data)
data.sort <- sort(data)
data.1qrt <- data.sort[ceiling(n/4)]
data.med <- data.sort[ceiling(n/2)]
data.3qrt <- data.sort[ceiling(3*n/4)]

# Output
cat("1st Quartile:", data.1qrt, "\n")
cat("Median:      ", data.med, "\n")
cat("3rd Quartile:", data.3qrt, "\n")

# program spuRs/resources/scripts/scoping.r
# Script to demonstrate the difference between passing and copying
# arguments.
# We use an artificial example with no real-world utility.

require(nlme)

fm1 <- lme(distance ~ age, data = Orthodont)
fm1$numIter <- 1

fm2 <- fm1

nochange <- function(x) {
  2 * x$numIter
  return(x)
}

change <- function(x) {
  x$numIter <- integer(2)
  return(x)
}

# program spuRs/resources/scripts/SIR_grid.r
# discrete SIR epidemic model
#
# initial susceptible population N
# initial infected population 1
# infection probability a
# removal probability b
#
# estimates expected final population size for different values of
# the infection probability a and removal probability b
# we observe a change in behaviour about the line Na = b
# (Na is the expected number of new infected at time 1 and
# b is the expected number of infected who are removed at time 1)

SIR <- function(a, b, N, T) {
  # simulates SIR epidemic model from time 0 to T
  # returns number of susceptibles, infected and removed at time T
  S <- N
  I <- 1
  R <- 0
  for (i in 1:T) {
    S <- rbinom(1, S, (1 - a)^I)
    R <- R + rbinom(1, I, b)
    I <- N + 1 - S - R
  }
  return(c(S, I, R))
}

# set parameter values
N <- 1000
T <- 100
a <- seq(0.0001, 0.001, by = 0.0001)
b <- seq(0.1, 0.5, by = 0.05)

n.reps <- 400 # sample size for estimating E S[T]
f.name <- "SIR_grid.dat" # file to save simulation results

# estimate E S[T] for each combination of a and b
write(c("a", "b", "S_T"), file = f.name, ncolumns = 3)
for (i in 1:length(a)) {
  for (j in 1:length(b)) {
    S.sum <- 0
    for (k in 1:n.reps) {
      S.sum <- S.sum + SIR(a[i], b[j], N, T)[1]
    }
    write(c(a[i], b[j], S.sum/n.reps), file = f.name, 
      ncolumns = 3, append = TRUE)
  }
}

# plot estimates in 3D
g <- read.table(f.name, header = TRUE)
library(lattice)
print(wireframe(S_T ~ a*b, data = g, scales = list(arrows = FALSE),
                aspect = c(.5, 1), drape = TRUE,
                xlab = "a", ylab = "b", zlab = "E S[T]"))

# program spuRs/resources/scripts/quad2b.r
# find the zeros of a2*x^2 + a1*x + a0 = 0

# clear the workspace
rm(list=ls())

# input
cat("find the zeros of a2*x^2 + a1*x + a0 = 0\n")
a2 <- as.numeric(readline("a2 = "))
a1 <- as.numeric(readline("a1 = "))
a0 <- as.numeric(readline("a0 = "))

# calculate the discriminant
discrim <- a1^2 - 4*a2*a0
# calculate the roots depending on the value of the discriminant
if (discrim > 0) {
    roots <- (-a1 + c(1,-1) * sqrt(a1^2 - 4*a2*a0))/(2*a2)
} else {
    if (discrim == 0) {
        roots <- -a1/(2*a2)
    } else {
        roots <- c()
    }
}

# output
if (length(roots) == 0) {
    cat("no roots\n")
} else if (length(roots) == 1) {
    cat("single root at", roots, "\n")
} else {
    cat("roots at", roots[1], "and", roots[2], "\n")
}

# program: spuRs/resources/scripts/quad1.r
# find the zeros of a2*x^2 + a1*x + a0 = 0

# clear the workspace
rm(list=ls())

# input
a2 <- 1
a1 <- 4
a0 <- 2

# calculation
root1 <- (-a1 + sqrt(a1^2 - 4*a2*a0))/(2*a2)
root2 <- (-a1 - sqrt(a1^2 - 4*a2*a0))/(2*a2)

# output
print(c(root1, root2))

# program spuRs/resources/scripts/trapezoid.r

trapezoid <- function(ftn, a, b, n = 100) {
  # numerical integral of ftn from a to b
  # using the trapezoid rule with n subdivisions
  #
  # ftn is a function of a single variable
  # we assume a < b and n is a positive integer
  
  h <- (b-a)/n
  x.vec <- seq(a, b, by = h)
  f.vec <- sapply(x.vec, ftn)
  T <- h*(f.vec[1]/2 + sum(f.vec[2:n]) + f.vec[n+1]/2)
  return(T)
}

# program spuRs/resources/scripts/MCEstimation.R
# loadable spuRs function

# This function estimates the transition matrix for a discrete MC
# with known state space {0,1,..,n}
# based on observations of the chain stored in statehist.

MCEstimation <- function(statehist, n) {
  ntrans <- length(statehist) - 1
  TC <- matrix(0, nrow = n+1, ncol = n+1)
  for (trans in 2:ntrans) {
    TC[statehist[trans - 1] + 1, statehist[trans] + 1] <-
      TC[statehist[trans - 1] + 1, statehist[trans] + 1] + 1
  }
  return(TC/rowSums(TC))
}

# program spuRs/resources/scripts/inventory2_sim.r

rm(list=ls())
set.seed(1939)
source("../scripts/add_event.r")

# inputs
# system parameters
D <- 1000
L <- 0.1
K <- 1000
p <- 100
h <- 100
s <- 200
# control parameters
q <- 146
r <- 115

# initialise system and event list
t <- 0
stock <- r
costs <- 0
event.list <- list(list(type = "purchase", time = rexp(1, rate = D)))
event.list <- add_event(event.list, list(type = "new stock", time = L))
# initialise data collection
total.cycles <- 1000
n.cycles <- 0
cost.per.unit.time <- rep(0, total.cycles)
t.cycle.start <- 0
costs.cycle.start <- 0
# simulation
while (n.cycles < total.cycles) {
  # get next event
  t.old <- t
  current.event <- event.list[[1]]
  event.list <- event.list[-1]
  # update state and event list according to type of current event
  if (current.event$type == "purchase") {
    # update system state
    t <- current.event$time
    if (stock > 0) {
      costs <- costs + h*stock*(t - t.old)
      stock <- stock - 1
    } else {
      costs <- costs + s
    }
    # generate next purchase
    new.event <- list(type = "purchase", time = t + rexp(1, rate = D))
    event.list <- add_event(event.list, new.event)
    # check for end of cycle
    if (stock == r) {
      # order more stock
      new.event <- list(type = "new stock", time = t + L)
      event.list <- add_event(event.list, new.event)
      costs <- costs + K + q*p
      # data collection
      n.cycles <- n.cycles + 1
      cost.per.unit.time[n.cycles] <- (costs - costs.cycle.start)/(t - t.cycle.start)
      t.cycle.start <- t
      costs.cycle.start <- costs
    }
  } else if (current.event$type == "new stock") {
    # update system state
    t <- current.event$time
    costs <- costs + h*stock*(t - t.old)
    stock <- stock + q
  }
}

show(mean(cost.per.unit.time))
show(mean(cost.per.unit.time) - 1.96*sd(cost.per.unit.time)/sqrt(total.cycles))
show(mean(cost.per.unit.time) + 1.96*sd(cost.per.unit.time)/sqrt(total.cycles))

# program: spuRs/resources/scripts/forest_fire.r
# forest fire simulation
rm(list = ls())

neighbours <- function(A, i, j) {
  # calculate number of neighbours of A[i,j] that are infected
  # we have to check for the edge of the grid
  nbrs <- 0
  # sum across row i - 1
  if (i > 1) {
    if (j > 1) nbrs <- nbrs + (A[i-1, j-1] == 1)
    nbrs <- nbrs + (A[i-1, j] == 1)
    if (j < ncol(A)) nbrs <- nbrs + (A[i-1, j+1] == 1)
  }
  # sum across row i
  if (j > 1) nbrs <- nbrs + (A[i, j-1] == 1)
  nbrs <- nbrs + (A[i, j] == 1)
  if (j < ncol(A)) nbrs <- nbrs + (A[i, j+1] == 1)
  # sum across row i + 1
  if (i < nrow(A)) {
    if (j > 1) nbrs <- nbrs + (A[i+1, j-1] == 1)
    nbrs <- nbrs + (A[i+1, j] == 1)
    if (j < ncol(A)) nbrs <- nbrs + (A[i+1, j+1] == 1)
  }
  return(nbrs)
}

forest.fire.plot <- function(X) {
  # plot infected and removed individuals
  for (i in 1:nrow(X)) {
    for (j in 1:ncol(X)) {
      if (X[i,j] == 1) points(i, j, col = "red", pch = 19)
      else if (X[i,j] == 0) points(i, j, col = "grey", pch = 19)
    }
  }
}

forest.fire <- function(X, a, b, pausing = FALSE) {
  # simulate forest fire epidemic model
  # X[i, j] = 2 for susceptible; 1 for infected; 0 for removed
  
  # set up plot
  plot(c(1,nrow(X)), c(1,ncol(X)), type = "n", xlab = "", ylab = "")
  forest.fire.plot(X)

  # main loop
  burning <- TRUE
  while (burning) {
    burning <- FALSE
    # check if pausing between updates
    if (pausing) {
      input <- readline("hit any key to continue")
    }

    # update
    B <- X
    for (i in 1:nrow(X)) {
      for (j in 1:ncol(X)) {
        if (X[i, j] == 2) {
          if (runif(1) > (1 - a)^neighbours(X, i, j)) {
            B[i, j] <- 1
          }
        } else if (X[i, j] == 1) {
          burning <- TRUE
          if (runif(1) < b) {
            B[i, j] <- 0
          }
        }
      }
    }
    X <- B
    
    # plot
    forest.fire.plot(X)
  }
  
  return(X)
}

# spark
set.seed(3)
X <- matrix(2, 21, 21)
X[11, 11] <- 1
# big fires
#X <- forest.fire(X, .1, .2, TRUE)
X <- forest.fire(X, .2, .4, TRUE)
# medium fires
#X <- forest.fire(X, .07, .2, TRUE)
#X <- forest.fire(X, .1, .4, TRUE)
# small fires
#X <- forest.fire(X, .05, .2, TRUE)
#X <- forest.fire(X, .07, .4, TRUE)

# program spuRs/resources/scripts/prime.r

prime <- function(n) {
    # returns TRUE if n is prime
    # assumes n is a positive integer
    if (n == 1) {
        is.prime <- FALSE
    } else if (n == 2) {
        is.prime <- TRUE
    } else {
        is.prime <- TRUE
        m <- 2
        m.max <- sqrt(n)  # only want to calculate this once
        while (is.prime && m <= m.max) {
            if (n %% m == 0) is.prime <- FALSE
            m <- m + 1
        }
    }
    return(is.prime)
}

# program spuRs/resources/scripts/hit_miss.r

hit_miss <- function(ftn, a, b, f.min, f.max, n) {
  # Monte-Carlo integration using the hit and miss method
  # ftn is a function of one variable
  # [a, b] is the range of integration
  # f.min and f.max are bounds on ftn over the range [a, b]
  # that is f.min <= ftn(x) <= f.max for all x in [a, b]
  # n is the number of samples used in the estimation
  # that is the number of calls made to the function ftn
  Z.sum <- 0
  for (i in 1:n) {
    X <- runif(1, a, b)
    Y <- runif(1, f.min, f.max)
    Z <- (ftn(X) >= Y)
    Z.sum <- Z.sum + Z
  }
  I <- (b - a)*f.min + (Z.sum/n)*(b - a)*(f.max - f.min)
  return(I)
}

hit_miss2 <- function(ftn, a, b, c, d, n) {
  # Monte-Carlo integration using the hit & miss method
  # partially vectorised version
  X <- runif(n, a, b)
  Y <- runif(n, c, d)
  Z <- (Y <= sapply(X, ftn))
  I <- (b - a)*c + (cumsum(Z)/(1:n))*(b - a)*(d - c)
  plot(1:n, I, type = "l")
  return(I[n])
}

booking_clerkMC <- function(person.arrival.rate,
                           call.arrival.rate,
                           person.service.rate,
                           call.service.rate,
                           t.end) {
  
# simulate the harassed booking clerk using a Markov chain
# state is a vector length 3
# first element is clerk state 0/1/2 for idle/serving a person/serving a call
# second element is number of people waiting
# third element is number of calls waiting

t <- 0 # start time
state <- c(0,0,0) # start state
t.hist <- t
state.hist <- state
while (t < t.end) {
  if (state[1] == 0) { #clerk idle
    rate.out <- person.arrival.rate + call.arrival.rate
    u <- runif(1)
    if (u < person.arrival.rate/rate.out) { # person arrives
      state <- c(1,0,0)
    } else { # call arrives
      state <- c(2,0,0)
    }
  } else if (state[1] == 1) { # clerk serving a person
    rate.out <- person.arrival.rate + call.arrival.rate + person.service.rate
    u <- runif(1)
    if (u < person.arrival.rate/rate.out) { # person arrives
      state[2] <- state[2] + 1
    } else if (u < (person.arrival.rate + call.arrival.rate)/rate.out) { # call arrives
      state[3] <- state[3] + 1
    } else { # finished serving
      if (state[2] > 0) { # still people
        state[2] <- state[2] - 1
      } else if (state[3] > 0) { # no people but calls
        state[1] <- 2
        state[3] <- state[3] - 1
      } else { # no people or calls
        state <- c(0,0,0)
      }
    }
  } else { # clerk serving a call
    rate.out <- person.arrival.rate + call.arrival.rate + call.service.rate
    u <- runif(1)
    if (u < person.arrival.rate/rate.out) { # person arrives
      state[2] <- state[2] + 1
    } else if (u < (person.arrival.rate + call.arrival.rate)/rate.out) { # call arrives
      state[3] <- state[3] + 1
    } else { # finished serving
      if (state[2] > 0) { # still people
        state[1] <- 1
        state[2] <- state[2] - 1
      } else if (state[3] > 0) { # no people but calls
        state[3] <- state[3] - 1
      } else { # no people or calls
        state <- c(0,0,0)
      }
    }
  }
  t <- t + rexp(1, rate.out)
  # data recording  
  t.hist <- c(t.hist, t)
  state.hist <- rbind(state.hist, state)
}   
return(cbind(t.hist, state.hist))
}


# sample call queue on a delta lattice from time tstart to tend
# repeat n times and average
# default rates give a heavily loaded system
call.sample <- function(tstart = 0, tend = 10000, delta = 1, n = 10, 
                        person.arrival.rate = 0.15, call.arrival.rate = 0.15) {
  m <- floor((tend-tstart)/delta) + 1
  callQ <- matrix(nrow = m, ncol = n)
  for (i in 1:n) {
    bcout <- booking_clerkMC(person.arrival.rate, call.arrival.rate, 0.3, 0.45, tend)
    callQ[,i] <- approx(bcout[,1], bcout[,4], xout=seq(tstart, tend, delta), 
                        method="constant", ties="ordered")$y
  }
  return(rowMeans(callQ))
}

# apply a moving average of width 2*w + 1
ma <- function(x, w) {
  n <- length(x)
  if (n < 2*w + 1) {
    m <- floor((n + 1)/2)
    y <- rep(0, m)
    for (i in 1:m) {
      y[i] <- mean(x[1:(2*i - 1)])
    }
  } else {
    y <- rep(0, n - w)
    for (i in 1:w) {
      y[i] <- mean(x[1:(2*i - 1)])
    }
    for (i in (w + 1):(n - w)) {
      y[i] <- mean(x[(i-w):(i+w)])
    }
  }
  return(y)
}

# effect of averaging and smoothing
# Welch's method
set.seed(20)
opar <- par(mfrow = c(3, 1))
#
tend <- 1000
delta <- 1
n <- 1
calls <- call.sample(0, tend, delta, n)
plot(seq(0, tend, delta), calls, type="l", 
     xlab="", ylab="", main=paste("n =", n))
#
n <- 10
calls <- call.sample(0, tend, delta, n)
plot(seq(0, tend, delta), calls, type="l", 
     xlab="", ylab="", main=paste("n =", n))
#     
w <- 200
callQ.w <- ma(calls, w)
plot(seq(0, tend, delta), c(callQ.w, rep(NA, w)), type="l", 
     xlab="", ylab="", main=paste("n =", n, "w =", w))
par(opar)

# choose burn in 800 and block size 400
# use blocking to estimate CI for mean queue size
set.seed(20)
burn_in <- 800
block_size <- 400 
n_blocks <- 50
delta <- 1
tend <- burn_in + block_size*n_blocks*delta
callQ <- call.sample(burn_in, tend, delta, 1)[-1]
# calculate block means
callQ_blocks <- matrix(callQ, ncol=n_blocks)
callQ_means <- colMeans(callQ_blocks)
# CI using blocks
cat("mean length call queue", mean(callQ_means), "+/-", 2*sd(callQ_means)/sqrt(n_blocks), "(using blocks)\n")
# CI without using blocks
cat("mean length call queue", mean(callQ), "+/-", 2*sd(callQ)/sqrt(length(callQ)), "(without blocks)\n")

# calculate sample autocorrelation
(rho <- acf(callQ_means, 1, plot=FALSE)$acf[2]) 
2*pnorm(abs(rho + 1/n_blocks), mean=0, sd=1/sqrt(n_blocks), lower.tail=FALSE) 

# effect of averaging and smoothing
# Welch's method
windows()
set.seed(20)
opar <- par(mfrow = c(4, 1))
#
tend <- 10000
delta <- 1
n <- 1
calls <- call.sample(0, tend, delta, n)
plot(seq(0, tend, delta), calls, type="l", 
     xlab="", ylab="", main=paste("n =", n))
#
n <- 10
calls <- call.sample(0, tend, delta, n)
plot(seq(0, tend, delta), calls, type="l", 
     xlab="", ylab="", main=paste("n =", n))
#
w <- 200
callQ.w <- ma(calls, w)
plot(seq(0, tend, delta), c(callQ.w, rep(NA, w)), type="l", 
     xlab="", ylab="", main=paste("n =", n, "w =", w))
#     
w <- 2000
callQ.w <- ma(calls, w)
plot(seq(0, tend, delta), c(callQ.w, rep(NA, w)), type="l", 
     xlab="", ylab="", main=paste("n =", n, "w =", w))
par(opar)

# choose burn in 2000 and block size 1000
# use blocking to estimate CI for mean queue size
set.seed(20)
burn_in <- 2000
block_size <- 1000 
n_blocks <- 50
delta <- 1
tend <- burn_in + block_size*n_blocks*delta
callQ <- call.sample(burn_in, tend, delta, 1)[-1]
# calculate block means
callQ_blocks <- matrix(callQ, ncol=n_blocks)
callQ_means <- colMeans(callQ_blocks)
# CI using blocks
cat("mean length call queue", mean(callQ_means), "+/-", 2*sd(callQ_means)/sqrt(n_blocks), "(using blocks)\n")
# CI without using blocks
cat("mean length call queue", mean(callQ), "+/-", 2*sd(callQ)/sqrt(length(callQ)), "(without blocks)\n")

# calculate sample autocorrelation
(rho <- acf(callQ_means, 1, plot=FALSE)$acf[2]) 
2*pnorm(abs(rho + 1/n_blocks), mean=0, sd=1/sqrt(n_blocks), lower.tail=FALSE) 


# for comparison, consider blocking for iid data
x_blocks <- matrix(rgamma(n_blocks*block_size, shape=2), ncol=n_blocks)
x_means <- apply(x_blocks, 2, mean)
cat("mean", mean(x_means), "+/-", 2*sd(x_means)/sqrt(n_blocks), "(using blocks)\n")
cat("mean", mean(x_blocks), "+/-", 2*sd(as.vector(x_blocks))/sqrt(length(x_blocks)), "(without blocks)\n")

# test ODE solvers euler, midpoint and RK4 by
# solving dy/dt = -y, y(0) = 1, from t = 0 to t = 1
# we halve the step size until a given accuracy is achieved

rm(list = ls())
source("../scripts/euler.r")
source("../scripts/midpoint.r")
source("../scripts/RK4.r")

dydt <- function(t=NULL, y) -y  # y(t) = y(0)*exp(-t)

last <- function(x) x[length(x)]

# tol.vec is a vector of tolerances
# for each element of tol.vec a col of ftn.calls
# counts the function calls by each solver
tol.vec <- 10^(-(1:6))
ftn.calls <- matrix(nrow=3, ncol=length(tol.vec))
for (i in 1:length(tol.vec)) {
  tol <- tol.vec[i]
  # euler
  h <- 1
  y <- last(euler(dydt, 0, 1, h, n=1/h))
  while (abs(y - exp(-1)) > tol) {
    h <- h/2
    y <- last(euler(dydt, 0, 1, h, n=1/h))
  }
  ftn.calls[1,i] <- 1/h
  # midpoint
  h <- 1
  y <- last(midpoint(dydt, 0, 1, h, n=1/h))
  while (abs(y - exp(-1)) > tol) {
    h <- h/2
    y <- last(midpoint(dydt, 0, 1, h, n=1/h))
  }
  ftn.calls[2,i] <- 2/h
  # RK4
  h <- 1
  y <- last(RK4(dydt, 0, 1, h, n=1/h))
  while (abs(y - exp(-1)) > tol) {
    h <- h/2
    y <- last(RK4(dydt, 0, 1, h, n=1/h))
  }
  ftn.calls[3,i] <- 4/h
}

# print tolerance vs function calls for each solver
# on a log-log scale
plot(-log(tol.vec), log(ftn.calls[1,]), type='b', pch=1,
     xlab = '-log(tolerance)', ylab = 'log(function calls)')
lines(-log(tol.vec), log(ftn.calls[2,]), type='b', pch=2)
lines(-log(tol.vec), log(ftn.calls[3,]), type='b', pch=3)
legend('topleft', legend = c('Euler', 'Midpoint', 'RK4'),
       pch = c(1, 2, 3), inset = .1)

# Program spuRs/resources/scripts/err.r

# clear the workspace
rm(list=ls())

random.sum <- function(n) {
    # sum of n random numbers
    x[1:n] <- ceiling(10*runif(n))
    cat("x:", x[1:n], "\n")
    return(sum(x))
}

x <- rep(100, 10)
show(random.sum(10))
show(random.sum(5))

# program: spuRs/resources/scripts/pension.r
# Forecast pension growth under compound interest

# clear the workspace
rm(list=ls())

# Inputs
r <- 0.11             # Annual interest rate
term <- 10            # Forecast duration (in years)
period <- 1/12        # Time between payments (in years)
payments <- 100       # Amount deposited each period

# Calculations
n <- floor(term/period)  # Number of payments
pension <- 0
for (i in 1:n) {
    pension[i+1] <- pension[i]*(1 + r*period) + payments
}
time <- (0:n)*period

# Output
plot(time, pension)

# program spuRs/resources/scripts/fixedpoint.r
# loadable spuRs function

fixedpoint <- function(ftn, x0, tol = 1e-9, max.iter = 100) {
  # applies the fixed-point algorithm to find x such that ftn(x) == x
  # we assume that ftn is a function of a single variable
  #
  # x0 is the initial guess at the fixed point
  # the algorithm terminates when successive iterations are
  # within distance tol of each other,
  # or the number of iterations exceeds max.iter

  # do first iteration
  xold <- x0
  xnew <- ftn(xold)
  iter <- 1
  cat("At iteration 1 value of x is:", xnew, "\n")

  # continue iterating until stopping conditions are met
  while ((abs(xnew-xold) > tol) && (iter < max.iter)) {
    xold <- xnew;
    xnew <- ftn(xold);
    iter <- iter + 1
    cat("At iteration", iter, "value of x is:", xnew, "\n")
  }

  # output depends on success of algorithm
  if (abs(xnew-xold) > tol) {
    cat("Algorithm failed to converge\n")
    return(NULL)
  } else {
    cat("Algorithm converged\n")
    return(xnew)
  }
}

# Code spuRs/resources/scripts/RK4adapt.r
# loadable spuRs function

RK4adapt <- function(dydt, t0, y0, t1, h0 = 1, tol = 1e-10, ...) {
  # 4-th order Runge-Kutta with adaptive step size
  # dydt(t, y, ...) gives the gradient of y(t)
  # t0 and y0 are starting conditions
  # The system is solved up to time t1. Initial step size is h0, 
  # which is adjusted so that the error in each step is approx tol.
  # Returns a list with elements t a vector giving times,
  # and y a matrix whose rows give the soltn at successive times.  
  t <- t0  # current time
  y <- y0  # current state
  h <- h0  # current step size
  t.vec <- t
  y.vec <- matrix(y, nrow=1)
  while (t < t1) {
    # RK4 using step size h
    k1 <- dydt(t, y, ...)
    k2 <- dydt(t + h/2, y + h*k1/2, ...)
    k3 <- dydt(t + h/2, y + h*k2/2, ...)
    k4 <- dydt(t + h, y + h*k3, ...)
    y1 <- y + h*(k1/6 + k2/3 + k3/3 + k4/6)
    # RK4 using two steps size h/2
    k1a <- k1
    k2a <- dydt(t + h/4, y + h/2*k1a/2, ...)
    k3a <- dydt(t + h/4, y + h/2*k2a/2, ...)
    k4a <- dydt(t + h/2, y + h/2*k3a, ...)
    y2 <- y + h/2*(k1a/6 + k2a/3 + k3a/3 + k4a/6)
    k1b <- dydt(t + h/2, y2, ...)
    k2b <- dydt(t + 3*h/4, y2 + h/2*k1b/2, ...)
    k3b <- dydt(t + 3*h/4, y2 + h/2*k2b/2, ...)
    k4b <- dydt(t + h, y2 + h/2*k3b, ...)
    y3 <- y2 + h/2*(k1b/6 + k2b/3 + k3b/3 + k4b/6)
    # update h (decrease)
    if (max(abs(y3 - y1)) > tol) {
      h <- h/2
    } else {
      # update t and y
      t <- t + h
      y <- y3 + (y3 - y1)/15
      # update h (increase)
      if (max(abs(y3 - y1)) < tol/2) h <- 3*h/2
      # record keeping
      t.vec <- c(t.vec, t)
      y.vec <- rbind(y.vec, y)
    }
  }
  return(list(t=t.vec, y=y.vec))
}

Q <- matrix(c(-24, 2, 0, 24, -14, 4, 0, 12, -4), 3, 3)
library(Matrix)
(Phalf <- expm(Q/2))
(Pone <- expm(Q))
(Ptwo <- expm(2*Q))

Phalf %*% Phalf
Pone %*% Pone

pi0 <- c(0,0,1)
(pi0 %*% Phalf)
(pi0 %*% Pone)
(pi0 %*% Ptwo)

A <- t(Q)
A[1,] <- c(1,1,1)
solve(A, c(1,0,0))

# exp time to hit 1
TQ <- Q[-1,-1]
solve(TQ, rep(-1,2))

# via simulation
(rates <- -diag(Q))
(P <- diag(1/rates) %*% Q + diag(1,3))

hit <- function(rates, P) {
  x <- 3
  t <- 0
  while (x > 1) {
    t <- t + rexp(1, rates[x])
    x <- sample(1:3, 1, prob = P[x,])
    #cat(x, t, "\n")
  }
  return(t)
}

N <- 1000000
hits <- rep(0, N)
for (i in 1:N) hits[i] <- hit(rates, P)
cat( mean(hits) - 2*sd(hits)/sqrt(N), mean(hits), mean(hits) + 2*sd(hits)/sqrt(N), "\n" )

# program spuRs/resources/scripts/wmean.r

wmean <- function(x, k) {
    # calculate the k-th Windsorised mean of the vector x
    x <- sort(x)
    n <- length(x)
    x[1:k] <- x[k+1]
    x[(n-k+1):n] <- x[n-k]
    return(mean(x))
}

# program: spuRs/resources/scripts/nfact1.r
# Calculate n factorial

# clear the workspace
rm(list=ls())

# Input
n <- 6

# Calculation
n_factorial <- 1
for (i in 1:n) {
    n_factorial <- n_factorial * i
}

# Output
show(n_factorial)

# program simpson_test.r
# test the accuracy of Simpson's rule
# using the integral of 1/x from 0.01 to 1

rm(list = ls()) # clear the workspace
source("../scripts/simpson_n.r")
ftn <- function(x) return(1/x)
S <- function(n) simpson_n(ftn, 0.01, 1, n)

n.vec <- seq(10, 1000, by = 10)
S.vec <- sapply(n.vec, S)

opar <- par(mfrow = c(1, 2), pty="s", mar=c(4,4,2,1), las=1)
plot(n.vec, S.vec + log(0.01), type = "l",
  xlab = "n", ylab = "error")
plot(log(n.vec), log(S.vec + log(0.01)), type = "l",
  xlab = "log(n)", ylab = "log(error)")
par(opar)

# program spuRs/resources/scripts/ma.r

ma <- function(x, w) {
  # apply a moving average of width 2*w + 1 to x
  n <- length(x)
  if (n < 2*w + 1) {
    m <- floor((n + 1)/2)
    y <- rep(0, m)
    for (i in 1:m) {
      y[i] <- mean(x[1:(2*i - 1)])
    }
  } else {
    y <- rep(0, n - w)
    for (i in 1:w) {
      y[i] <- mean(x[1:(2*i - 1)])
    }
    for (i in (w + 1):(n - w)) {
      y[i] <- mean(x[(i-w):(i+w)])
    }
  }
  return(y)
}

# program spuRs/resources/scripts/bisection.r
# loadable spuRs function

bisection <- function(ftn, x.l, x.r, tol = 1e-9) {
  # applies the bisection algorithm to find x such that ftn(x) == 0
  # we assume that ftn is a function of a single variable
  #
  # x.l and x.r must bracket the fixed point, that is
  # x.l < x.r and ftn(x.l) * ftn(x.r) < 0
  #
  # the algorithm iteratively refines x.l and x.r and terminates when
  # x.r - x.l <= tol

  # check inputs
  if (x.l >= x.r) {
    cat("error: x.l >= x.r \n")
    return(NULL)
  } 
  f.l <- ftn(x.l)
  f.r <- ftn(x.r)
  if (f.l == 0) {
    return(x.l)
  } else if (f.r == 0) {
    return(x.r)
  } else if (f.l * f.r > 0) {
    cat("error: ftn(x.l) * ftn(x.r) > 0 \n")
    return(NULL)
  }

  # successively refine x.l and x.r
  n <- 0
  while ((x.r - x.l) > tol) {
    x.m <- (x.l + x.r)/2
    f.m <- ftn(x.m)
    if (f.m == 0) {
      return(x.m)
    } else if (f.l * f.m < 0) {
      x.r <- x.m
      f.r <- f.m
    } else {
      x.l <- x.m
      f.l <- f.m
    }
    n <- n + 1
    cat("at iteration", n, "the root lies between", x.l, "and", x.r, "\n")
  }

  # return (approximate) root
  return((x.l + x.r)/2)
}

# Program spuRs/resources/scripts/status.test.r

status.test <- function(s.ftn) {
  x.vec <- (-1):11
  y.vec <- (-1):11
  plot(x.vec, y.vec, type = "n", xlab = "x", ylab = "y")
  for (x in x.vec) {
    for (y in y.vec) {
      s <- s.ftn(x, y)
      if (s == "impossible") text(x, y, "X", col = "red")
      else if (s == "unfinished") text(x, y, "?", col = "blue")
      else if (s == "player 1 win") text(x, y, "1", col = "green")
      else if (s == "player 2 win") text(x, y, "2", col = "green")
    }
  }
  return(invisible(NULL))
}

# program spuRs/resources/scripts/binom.sim.r

binom.sim <- function(n, p) {
  X <- 0
  px <- (1-p)^n
  Fx <- px
  U <- runif(1)
  while (Fx < U) {
    X <- X + 1
    px <- px*p/(1-p)*(n-X+1)/X
    Fx <- Fx + px
  }
  return(X)
}

# program spuRs/resources/scripts/lmap.r

# discrete dynamical system generated by the logistic map

lmap <- function(x1, r, n) {
    x <- x1
    for (i in 2:n) {
        x[i] <- r*x[i-1]*(1-x[i-1])
    }
    plot(x, main = paste("r = ", as.character(r)), xlab = "n", ylab = "x[n]")
}

par(mfrow = c(3,3), mar=c(4,4,4,3), las=1)
lmap(runif(1), 1.5, 100)
lmap(runif(1), 2.9, 100)
lmap(runif(1), 3.1, 100)
lmap(runif(1), 3.5, 100)
lmap(runif(1), 3.56, 100)
lmap(runif(1), 3.57, 500)
lmap(runif(1), 3.58, 500)
lmap(runif(1), 3.8, 500)
lmap(runif(1), 4, 500)

# program spuRs/resources/scripts/rejecttriangle.r

rejectionK <- function(fx, a, b, K) {
  # simulates from the pdf fx using the rejection algorithm
  # assumes fx is 0 outside [a, b] and bounded by K
  # note that we exit the infinite loop using the return statement
  while (TRUE) {
    x <- runif(1, a, b)
    y <- runif(1, 0, K)
    if (y < fx(x)) return(x)
  }
}

fx<-function(x){
  # triangular density
  if ((0<x) && (x<1)) {
    return(x)
  } else if ((1<x) && (x<2)) {
    return(2-x)
  } else {
    return(0)
  }
}

# generate a sample
set.seed(21)
nreps <- 3000
Observations <- rep(0, nreps)
for(i in 1:nreps)   {
  Observations[i] <- rejectionK(fx, 0, 2, 1)
}

# plot a scaled histogram of the sample and the density on top
hist(Observations, breaks = seq(0, 2, by=0.1), freq = FALSE,
     ylim = c(0, 1.05), main = "")
lines(c(0, 1, 2), c(0, 1, 0))

# Code spuRs/resources/scripts/RK4.r

RK4 <- function(dydt, t0, y0, h, n, ...) {
  # Runge-Kutta 4 applied to the system of ODEs with grad ftn dydt
  # and initial condition y0 at time t0
  # simulates n steps of size h, returned in a matrix with n + 1 rows 
  # and cols corresponding to the elements of y
  # additional arguments are passed to dydt
  y <- matrix(0, nrow = n+1, ncol = length(y0))
  y[1,] <- y0
  t <- t0
  for (i in 1:n) {
    k1 <- dydt(t, y[i,], ...)
    k2 <- dydt(t + h/2, y[i,] + h*k1/2, ...)
    k3 <- dydt(t + h/2, y[i,] + h*k2/2, ...)
    k4 <- dydt(t + h, y[i,] + h*k3, ...)
    y[i+1,] <- y[i,] + h*(k1/6 + k2/3 + k3/3 + k4/6)
    t <- t + h
  }
  return(y)
}

# function spuRs/resources/scripts/nfact2.r
# calculate n factorial

nfact2 <- function(n) {
    if (n == 1) {
        cat("called nfact2(1)\n")
        return(1)
    } else {
        cat("called nfact2(", n, ")\n", sep = "")
        return(n*nfact2(n-1))
    }
}

# program spuRs/resources/scripts/gamma.sim.r

gamma.sim <- function(lambda, m) {
  # sim a gamma(lambda, m) rv using rejection with an exp envelope
  # assumes m > 1 and lambda > 0
  f <- function(x) lambda^m*x^(m-1)*exp(-lambda*x)/gamma(m)
  h <- function(x) lambda/m*exp(-lambda/m*x)
  k <- m^m*exp(1-m)/gamma(m)
  while (TRUE) {
    X <- -log(runif(1))*m/lambda
    Y <- runif(1, 0, k*h(X))
    if (Y < f(X)) return(X)
  }
}

set.seed(1999)
n <- 10000
g <- rep(0, n)
for (i in 1:n) g[i] <- gamma.sim(1, 2)
hist(g, breaks=20, freq=F, xlab="x", ylab="pdf f(x)",
  main="theoretical and simulated gamma(1, 2) density")
x <- seq(0, max(g), .1)
lines(x, dgamma(x, 2, 1))

# program spuRs/resources/scripts/fixedpoint_show.r
# loadable spuRs function

fixedpoint_show <- function(ftn, x0, xmin = x0-1, xmax = x0+1) {
  # applies fixed-point method to find x such that ftn(x) == x
  # x0 is the starting point
  # subsequent iterations are plotted in the range [xmin, xmax]

  # plot the function
  x <- seq(xmin, xmax, (xmax - xmin)/200)
  fx <- sapply(x, ftn)
  plot(x, fx, type = "l", xlab = "x", ylab = "f(x)",
    main = "fixed point f(x) = x", col = "blue", lwd = 2)
  lines(c(xmin, xmax), c(xmin, xmax), col = "blue")

  # do first iteration
  xold <- x0
  xnew <- ftn(xold)
  lines(c(xold, xold, xnew), c(xold, xnew, xnew), col = "red")
  lines(c(xnew, xnew), c(xnew, 0), lty = 2, col = "red")

  # continue iterating while user types "y"
  cat("last x value", xnew, " ")
  continue <- readline("continue (y or n)? ") == "y"
  while (continue) {
    xold <- xnew;
    xnew <- ftn(xold);
    lines(c(xold, xold, xnew), c(xold, xnew, xnew), col = "red")
    lines(c(xnew, xnew), c(xnew, 0), lty = 2, col = "red")
    cat("last x value", xnew, " ")
    continue <- readline("continue (y or n)? ") == "y"
  }

  return(xnew)
}

# program: spurs/resources/scripts/add_event.r

add_event <- function(event.list, new.event) {
  # add new.event to event.list
  N <- length(event.list)
  if (N == 0) return(list(new.event))
  # find position n of new.event
  n <- 1
  while ((n <= N) && (new.event$time > event.list[[n]]$time)) {
    n <- n + 1
  }
  # add new.event to event.list
  if (n == 1) {
    event.list <- c(list(new.event), event.list)
  } else if (n == N + 1) {
    event.list <- c(event.list, list(new.event))
  } else {
    event.list <- c(event.list[1:(n-1)],
                    list(new.event),
                    event.list[n:N])
  }
  return(event.list)
}

# Program spuRs/resources/scripts/moverings.r

# Tower of Hanoi

moverings <- function(numrings, frompole, topole) {
  if (numrings == 1) {
    cat("move ring 1 from pole", frompole,
        "to pole", topole, "\n")
  } else {
    sparepole <- 6 - frompole - topole # clever
    moverings(numrings - 1, frompole, sparepole)
    cat("move ring", numrings, "from pole", frompole,
        "to pole", topole, "\n")
    moverings(numrings - 1, sparepole, topole)
  }
  return(invisible(NULL))
}

# program: spuRs/resources/scripts/fibonacci.r
# calculate the first Fibonacci number greater than 100

# clear the workspace
rm(list=ls())

# initialise variables
F <- c(1, 1) # list of Fibonacci numbers
n <- 2       # length of F

# iteratively calculate new Fibonacci numbers
while (F[n] <= 100) {
    # cat("n =", n, " F[n] =", F[n], "\n")
    n <- n + 1
    F[n] <- F[n-1] + F[n-2]
}

# output
cat("The first Fibonacci number > 100 is F(", n, ") =", F[n], "\n")

# Code spuRs/resources/scripts/lander.r

lander <- function(Ti, a, h = 0.1, tol = 1e-2, plot.traj = FALSE) {
  # Solve the trajectory of a rocket.
  # The rocket falls until time Ti (s), then produces thrust a (kg m/s^2), 
  # until the velocity is +ve, it hits the ground, or the fuel runs out, 
  # at which point the simulation stops.
  #
  # h is initial step size for adaptive RK4
  # tol is tolerance for adaptive RK4
  # plot.traj flag for plotting trajectories
  #
  # state y = (velocity m/s, height m, mass kg)
  # lander returns the final value of y
  
  v0 = -1000   # initial velocity m/s
  ht0 = 50000  # initial height m
  m0 <- 10000  # unladen mass of rocket kg
  f <- 1500    # initial fuel load kg
  r <- 0.0001  # mass of fuel burnt per unit thrust per unit time s/m
  g <- 1.633   # acceleration due to gravity m/s^2
  
  # derivatives of y at time t
  dydt <- function(t, y) {
    if (t < Ti) {
      return(c(-g, y[1], 0))
    } else {
      return(c(a/y[3] - g, y[1], -r*a))
    }
  }
  
  # 4-th order Runge-Kutta with adaptive step size
  t <- 0
  y <- c(v0, ht0, m0 + f)
  if (plot.traj) y.trace <- c(t, y)
  while (y[1] < 0 && y[2] > 0 && y[3] > m0) { 
    # readline(paste(t, y[1], y[2]))  # for step-by-step reporting
    # RK4 using step size h
    k1 <- dydt(t, y)
    k2 <- dydt(t + h/2, y + h*k1/2)
    k3 <- dydt(t + h/2, y + h*k2/2)
    k4 <- dydt(t + h, y + h*k3)
    y1 <- y + h*(k1/6 + k2/3 + k3/3 + k4/6)
    # RK4 using two steps size h/2
    k1a <- k1
    k2a <- dydt(t + h/4, y + h/2*k1a/2)
    k3a <- dydt(t + h/4, y + h/2*k2a/2)
    k4a <- dydt(t + h/2, y + h/2*k3a)
    y2 <- y + h/2*(k1a/6 + k2a/3 + k3a/3 + k4a/6)
    k1b <- dydt(t + h/2, y2)
    k2b <- dydt(t + 3*h/4, y2 + h/2*k1b/2)
    k3b <- dydt(t + 3*h/4, y2 + h/2*k2b/2)
    k4b <- dydt(t + h, y2 + h/2*k3b)
    y3 <- y2 + h/2*(k1b/6 + k2b/3 + k3b/3 + k4b/6)
    y.new <- y3 + (y3 - y1)/15
    # update h (decrease)
    if (max(abs(y3 - y1)) > tol || 
        y.new[1] >= tol || y.new[2] <= -tol || y.new[3] <= m0 - tol) {
      h <- h/2
    } else {
      # update t and y
      t <- t + h
      y <- y.new
      # update h (increase)
      if (max(abs(y3 - y1)) < tol/2) h <- 3*h/2
      # record keeping
      if (plot.traj) y.trace <- rbind(y.trace, c(t, y))
    }
  }  

  # output
  if (plot.traj) {
    opar <- par(mfrow=c(3,1), mar=c(4,4,1,1))
    plot(y.trace[,1], y.trace[,2], type='o', xlab='t', ylab='velocity')
    plot(y.trace[,1], y.trace[,3], type='o', xlab='t', ylab='height')
    plot(y.trace[,1], y.trace[,4], type='o', xlab='t', ylab='mass')
    par <- opar
  }
  return(y)
}

# program: spuRs/resources/scripts/inventory_sim.r

rm(list=ls())
set.seed(1939)
source("../scripts/add_event.r")

# inputs
# system parameters
D <- 1000
L <- 0.1
K <- 1000
p <- 100
h <- 100
s <- 200
# control parameters
q <- 146
r <- 115

# initialise system and event list
n <- 0  # number of events so far
t <- 0  # time
stock <- r
costs <- 0
event.list <- list(list(type = "purchase", time = rexp(1, rate = D)))
event.list <- add_event(event.list, list(type = "new stock", time = L))
# initialise stopping condition
time.to.stop <- FALSE
# simulation
while (!time.to.stop) {
  # get next event
  current.event <- event.list[[1]]
  event.list <- event.list[-1]
  n <- n + 1
  # update state and event list according to type of current event
  if (current.event$type == "purchase") {
    # update system state
    t[n+1] <- current.event$time
    if (stock[n] > 0) {  # reduce inventory, update holding costs
      costs[n+1] <- costs[n] + h*stock[n]*(t[n+1] - t[n])
      stock[n+1] <- stock[n] - 1
    } else {             # lost sale
      costs[n+1] <- costs[n] + s
      stock[n+1] <- stock[n]
    }
    # generate next purchase
    new.event <- list(type = "purchase",
                      time = t[n+1] + rexp(1, rate = D))
    event.list <- add_event(event.list, new.event)
    # check for end of cycle
    if (stock[n+1] == r) {
      # order more stock
      new.event <- list(type = "new stock", time = t[n+1] + L)
      event.list <- add_event(event.list, new.event)
      costs[n+1] <- costs[n+1] + K + q*p
    }
  } else if (current.event$type == "new stock") {
    # update system state
    t[n+1] <- current.event$time
    costs[n+1] <- costs[n] + h*stock[n]*(t[n+1] - t[n])
    stock[n+1] <- stock[n] + q
  }
  # check stopping condition
  if (stock[n+1] == r) time.to.stop <- TRUE
}

# program: spuRs/resources/scripts/expex.r
#
# calculating the mean of a discrete rv X

x <- 1/(1000:1)              # possible values for X
pX <- x^1.5                  # probability mass ftn
pX <- pX/sum(pX)             # must have sum(pX) == 1
muX <- sum(x*pX)             # mean

# plot the pmf and mean
par(las=1)
plot(c(0, 1), c(0, max(pX)), type="n", xlab="x", ylab="p(x)")
lines(x, pX, type="h")
points(muX, 0, pch=19)
text(muX, 0, "mean", pos=4)
